wayland::server::touch_t(3)

NAME
wayland::server::touch_t - touchscreen input device

SYNOPSIS

#include <wayland-server-protocol.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void()> & on_release ()
release the touch object
void down (uint32_t serial, uint32_t time, surface_t const &surface, int32_t id, double x, double y, bool post=true)
touch down event and beginning of a touch sequence
void up (uint32_t serial, uint32_t time, int32_t id, bool post=true)
end of a touch event sequence
void motion (uint32_t time, int32_t id, double x, double y, bool post=true)
update of touch point coordinates
void frame (bool post=true)
end of touch frame event
void cancel (bool post=true)
touch session cancelled
void shape (int32_t id, double major, double minor, bool post=true)
update shape of touch point
bool can_shape () const
Check whether the shape function is available with the currently bound version of the protocol.
void orientation (int32_t id, double orientation, bool post=true)
update orientation of touch point
bool can_orientation () const
Check whether the orientation function is available with the currently bound version of the protocol.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t down_since_version = 1
Minimum protocol version required for the down function.
static constexpr std::uint32_t up_since_version = 1
Minimum protocol version required for the up function.
static constexpr std::uint32_t motion_since_version = 1
Minimum protocol version required for the motion function.
static constexpr std::uint32_t frame_since_version = 1
Minimum protocol version required for the frame function.
static constexpr std::uint32_t cancel_since_version = 1
Minimum protocol version required for the cancel function.
static constexpr std::uint32_t shape_since_version = 6
Minimum protocol version required for the shape function.
static constexpr std::uint32_t orientation_since_version = 6
Minimum protocol version required for the orientation function.

Detailed Description

touchscreen input device

The wl_touch interface represents a touchscreen associated with a seat.

Touch interactions can consist of one or more contacts. For each contact, a series of events is generated, starting with a down event, followed by zero or more motion events, and ending with an up event. Events relating to the same contact point can be identified by the ID of the sequence.

Definition at line 3492 of file wayland-server-protocol.hpp.

Member Function Documentation

  bool touch_t::can_orientation () const

Check whether the orientation function is available with the currently bound version of the protocol.

Definition at line 2906 of file wayland-server-protocol.cpp.

  bool touch_t::can_shape () const

Check whether the shape function is available with the currently bound version of the protocol.

Definition at line 2896 of file wayland-server-protocol.cpp.

  void touch_t::cancel (bool post = true)

touch session cancelled Sent if the compositor decides the touch stream is a global gesture. No further events are sent to the clients from that particular gesture. Touch cancellation applies to all touch points currently active on this client's surface. The client is responsible for finalizing the touch points, future touch points on this surface may reuse the touch point ID.

Definition at line 2886 of file wayland-server-protocol.cpp.

  void touch_t::down (uint32_t serial, uint32_t time, surface_t const & surface, int32_t id, double x, double y, bool post = true)

touch down event and beginning of a touch sequence

Parameters
    serial serial number of the touch down event
    time timestamp with millisecond granularity
    surface surface touched
    id the unique ID of this touch point
    x surface-local x coordinate
    y surface-local y coordinate

A new touch point has appeared on the surface. This touch point is assigned a unique ID. Future events from this touch point reference this ID. The ID ceases to be valid after a touch up event and may be reused in the future.

Definition at line 2866 of file wayland-server-protocol.cpp.

  void touch_t::frame (bool post = true)

end of touch frame event Indicates the end of a set of events that logically belong together. A client is expected to accumulate the data in all events within the frame before proceeding.

A wl_touch.frame terminates at least one event but otherwise no guarantee is provided about the set of events within a frame. A client must assume that any state not updated in a frame is unchanged from the previously known state.

Definition at line 2881 of file wayland-server-protocol.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  void touch_t::motion (uint32_t time, int32_t id, double x, double y, bool post = true)

update of touch point coordinates

Parameters
    time timestamp with millisecond granularity
    id the unique ID of this touch point
    x surface-local x coordinate
    y surface-local y coordinate

A touch point has changed coordinates.

Definition at line 2876 of file wayland-server-protocol.cpp.

  std::function< void()> & touch_t::on_release ()

release the touch object

Definition at line 2860 of file wayland-server-protocol.cpp.

  void touch_t::orientation (int32_t id, double orientation, bool post = true)

update orientation of touch point

Parameters
    id the unique ID of this touch point
    orientation angle between major axis and positive surface y-axis in degrees

Sent when a touchpoint has changed its orientation.

This event does not occur on its own. It is sent before a wl_touch.frame event and carries the new shape information for any previously reported, or new touch points of that frame.

Other events describing the touch point such as wl_touch.down, wl_touch.motion or wl_touch.shape may be sent within the same wl_touch.frame. A client should treat these events as a single logical touch point update. The order of wl_touch.shape, wl_touch.orientation and wl_touch.motion is not guaranteed. A wl_touch.down event is guaranteed to occur before the first wl_touch.orientation event for this touch ID but both events may occur within the same wl_touch.frame.

The orientation describes the clockwise angle of a touchpoint's major axis to the positive surface y-axis and is normalized to the -180 to +180 degree range. The granularity of orientation depends on the touch device, some devices only support binary rotation values between 0 and 90 degrees.

This event is only sent by the compositor if the touch device supports orientation reports.

Definition at line 2901 of file wayland-server-protocol.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void touch_t::shape (int32_t id, double major, double minor, bool post = true)

update shape of touch point

Parameters
    id the unique ID of this touch point
    major length of the major axis in surface-local coordinates
    minor length of the minor axis in surface-local coordinates

Sent when a touchpoint has changed its shape.

This event does not occur on its own. It is sent before a wl_touch.frame event and carries the new shape information for any previously reported, or new touch points of that frame.

Other events describing the touch point such as wl_touch.down, wl_touch.motion or wl_touch.orientation may be sent within the same wl_touch.frame. A client should treat these events as a single logical touch point update. The order of wl_touch.shape, wl_touch.orientation and wl_touch.motion is not guaranteed. A wl_touch.down event is guaranteed to occur before the first wl_touch.shape event for this touch ID but both events may occur within the same wl_touch.frame.

A touchpoint shape is approximated by an ellipse through the major and minor axis length. The major axis length describes the longer diameter of the ellipse, while the minor axis length describes the shorter diameter. Major and minor are orthogonal and both are specified in surface-local coordinates. The center of the ellipse is always at the touchpoint location as reported by wl_touch.down or wl_touch.move.

This event is only sent by the compositor if the touch device supports shape reports. The client has to make reasonable assumptions about the shape if it did not receive this event.

Definition at line 2891 of file wayland-server-protocol.cpp.

  void touch_t::up (uint32_t serial, uint32_t time, int32_t id, bool post = true)

end of a touch event sequence

Parameters
    serial serial number of the touch up event
    time timestamp with millisecond granularity
    id the unique ID of this touch point

The touch point has disappeared. No further events will be sent for this touch point and the touch point's ID is released and may be reused in a future touch down event.

Definition at line 2871 of file wayland-server-protocol.cpp.

Member Data Documentation

  constexpr std::uint32_t wayland::server::touch_t::cancel_since_version = 1 [static], [constexpr]

Minimum protocol version required for the cancel function.

Definition at line 3606 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::touch_t::down_since_version = 1 [static], [constexpr]

Minimum protocol version required for the down function.

Definition at line 3541 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::touch_t::frame_since_version = 1 [static], [constexpr]

Minimum protocol version required for the frame function.

Definition at line 3590 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::touch_t::motion_since_version = 1 [static], [constexpr]

Minimum protocol version required for the motion function.

Definition at line 3572 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::touch_t::orientation_since_version = 6 [static], [constexpr]

Minimum protocol version required for the orientation function.

Definition at line 3684 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::touch_t::shape_since_version = 6 [static], [constexpr]

Minimum protocol version required for the shape function.

Definition at line 3644 of file wayland-server-protocol.hpp.

  constexpr std::uint32_t wayland::server::touch_t::up_since_version = 1 [static], [constexpr]

Minimum protocol version required for the up function.

Definition at line 3557 of file wayland-server-protocol.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.